import { Component, OnInit } from '@angular/core';
import { MatDialog, MatDialogRef, MAT_DIALOG_DATA, MatDialogModule, MatDialogConfig } from '@angular/material/dialog';
import {OverlayContainer} from '@angular/cdk/overlay';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Subscription } from 'rxjs';
import { Router, NavigationStart } from '@angular/router';

import {Strudelapp} from '../strudelapp';
import { StrudelappsService } from '../strudelapps.service';
import { TesService } from '../tes.service';
import {BackendSelectionService } from '../backend-selection.service';
import { AuthorisationService } from '../authorisation.service';
import { Identity } from '../identity';
import { Computesite } from '../computesite';
import { LogoutdialogComponent } from '../logoutdialog/logoutdialog.component';
import { SshAuthzServer } from '../identity';
import { ComputesitesService } from '../computesites.service';

import {DomSanitizer} from '@angular/platform-browser';
import {PipeTransform, Pipe} from "@angular/core";

@Pipe({ name: 'safeHtml'})
export class SafeHtmlPipe implements PipeTransform  {
  constructor(private sanitized: DomSanitizer) {}
  transform(value) {
    return this.sanitized.bypassSecurityTrustHtml(value);
  }
}

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.css']
})
export class LoginComponent implements OnInit {
  public strudelapps: Strudelapp[];

  public app: Strudelapp;
  public authorised: boolean;
  public identity: Identity;

  public identities: Identity[];
  public sshauthzservers: SshAuthzServer[];
  private launchwindow: any;
  private launchwindowWatcher: any;
  public selectedApiServer: any;
  private file: any;
  private config: any;
  public selected: any;
  private subscriptions: Subscription[];


  constructor( public dialog: MatDialog,
                public tesService: TesService,
                public backendSelectionService: BackendSelectionService,
                public authService: AuthorisationService,
                public computeSitesService: ComputesitesService,
                public overlayContainer: OverlayContainer,
                private router: Router,
                ) {


      this.subscriptions = []
      this.subscriptions.push(this.authService.sshAuthzServers.subscribe(o => {this.updateSshAuthZServers(o)}));
       
  }
    
  updateSshAuthZServers(o) {
    this.sshauthzservers = o;
  }

  ngOnInit() {
    //this.subscriptions.push(this.computeSitesService.appidentities.subscribe(o => this.navLaunch(o)));
    let navlaunch = localStorage.getItem('strudel-navlaunch')
    if (navlaunch == 'true') {
      localStorage.setItem('strudel-navlaunch',null)
      this.subscriptions.push(this.computeSitesService.appidentities.subscribe(o => this.navLaunch(o)));
    }
  }

  ngOnDestroy() {
    for (let s of this.subscriptions) {
      s.unsubscribe();
    }
  }

  navLaunch(o) {
    if (this.computeSitesService.appidentities.value !== null && this.computeSitesService.appidentities.value.length > 0) {
      this.router.navigate(['/launch']);
    }
  }


  login () {
    localStorage.setItem('strudel-navlaunch','true');
    this.authService.login(this.selected);
  }
}

